/*
   Domino 1.0: Programma di Domino a 3,4,5 giocatori
   Copyright (C) 2005  Destroyer

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

package Domino;

import java.io.*;

public class CaricaClasse extends ClassLoader{

    
    public static boolean isValidGiocatore(String classe){
    
    CaricaClasse cc;    
    Class c;
    

    cc=new CaricaClasse();   
    c=cc.caricaClasse(classe);    
        
    if (c==null) return false; 
    
    Class s=c.getSuperclass();
   
    if (s.getName().equalsIgnoreCase(superclasse)) return true;
   
    return false;    
        
    }
    
    public static Giocatore LoadGiocatore(String classe,String nomeg,Domino d){
    
    Giocatore g;
    CaricaClasse cc;    
    Class c;
    

    cc=new CaricaClasse();   
    c=cc.caricaClasse(classe);     
    
    Class[] typ={String.class,Domino.class};
    Object[] par={nomeg,d};
    
    try{
    g=(Giocatore)c.getConstructor(typ).newInstance(par);
    }catch(Exception e){return null;}
    
    return g;
    }  

    
    private Class caricaClasse(String classe){
        byte[] result; 
        Class c;
        
        try{
        FileInputStream fi = new FileInputStream( classe+".class" ) ;
        result = new byte[ fi.available() ] ;
        fi.read( result ) ;
        fi.close();
        }catch(IOException e){
            return null;}
       
        c=defineClass(classe,result,0,result.length);
        
        if (c!=null)
        resolveClass(c);
                
        return c;
    }
    
    
    public static String leggiAbout(String classe){
    
    if (0==classe.compareToIgnoreCase("CpuPlayer")) return CpuPlayer.about();   
        
    CaricaClasse cc;    
    Class c;
    
    cc=new CaricaClasse();   
    c=cc.caricaClasse(classe);     
    try{
    return (String)c.getMethod("about").invoke(null);
    }catch(Exception e){return null;}
    
    }
    
    private final static String superclasse="Domino.Giocatore";
        
}
