/*
   Domino 1.0: Programma di Domino a 3,4,5 giocatori
   Copyright (C) 2005  Destroyer

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

package Domino;


public class EndDialog extends javax.swing.JDialog {
    
   
    public EndDialog(java.awt.Frame parent, boolean modal,Graph p,Domino d) {
        super(parent, modal);
        this.p=p;
        this.d=d;
        initComponents();
    }
    
    private void initComponents() {
        jLabel =new javax.swing.JLabel[d.numeroG()];

        getContentPane().setLayout(new java.awt.GridLayout(d.numeroG()+1, 0));
        setDefaultCloseOperation(javax.swing.WindowConstants.DO_NOTHING_ON_CLOSE);
        setTitle("Fine partita");
        
        for (int i=0;i<jLabel.length;i++){        
        jLabel[i]=new javax.swing.JLabel();
        getContentPane().add(jLabel[i]);
        }
        
        for (int i=0;i<d.numeroG();i++){ 
        jLabel[d.getG(i).getPosizione()-1].setText(d.getG(i).getPosizione()+" "+d.getG(i).nome);
        }
        
        jPanel1 = new javax.swing.JPanel();
        jButton1 = new javax.swing.JButton();

        jButton1.setText("ok");
        jPanel1.add(jButton1);
          
        jButton1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton1ActionPerformed(evt);
            }
        });
        
        getContentPane().add(jPanel1);

        pack();
        Graph.centraWindow(this);
    }

    private void jButton1ActionPerformed(java.awt.event.ActionEvent evt) {                                         
    d.reset();
    p.repaint();
    this.setVisible(false); 
    }
    
    private Graph p;
    private Domino d;

    private javax.swing.JButton jButton1;
    private javax.swing.JLabel[] jLabel;
    private javax.swing.JPanel jPanel1;

    
}
