/*
   Domino 1.0: Programma di Domino a 3,4,5 giocatori
   Copyright (C) 2005  Destroyer

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

package Domino;

import java.util.Vector;
import java.io.File;
import javax.swing.JFrame;

public class SelCP extends javax.swing.JDialog {
    

    public SelCP(JFrame parent, boolean modal, Graph p, Domino d) {
        super(parent,"Selezione Giocatori",modal);
        this.p=p;
        this.d=d;
        f=parent;
        pl=new boolean[4];
        initComponents();
        setJCB();
        findAndAddP();
        pack();
        Graph.centraWindow(this);
    }
    
    public void findAndAddP(){
    
    Vector<String> v=new Vector<String>(0,1);    
    
    File d = new File("./");
   
    File[] f=d.listFiles();
  
    for (int i=0;i<f.length;i++)
        if (f[i].getName().endsWith(".class") && CaricaClasse.isValidGiocatore(f[i].getName().substring(0, f[i].getName().length()-6)))
          v.add(f[i].getName());
   
    
    
    for (int i=0;i<v.size();i++){        
        String cl=v.elementAt(i).substring(0, v.elementAt(i).length()-6);
        if (!cl.equals("CpuPlayer") && !cl.equals("RandomPlayer") && !cl.equals("LocalPlayer") && !cl.equals("NetPlayer")){
        jComboBox1.addItem(cl);
        jComboBox2.addItem(cl);
        jComboBox3.addItem(cl);
        jComboBox4.addItem(cl); 
    }}
        
        
    }  
    
    
    
    private void setJCB(){
    
        jComboBox1.addItem("No Player 2");
        jComboBox2.addItem("No Player 3");
        jComboBox3.addItem("No Player 4");
        jComboBox4.addItem("No Player 5"); 
        jComboBox1.addItem("CpuPlayer");
        jComboBox2.addItem("CpuPlayer");
        jComboBox3.addItem("CpuPlayer");
        jComboBox4.addItem("CpuPlayer"); 
        
        jButton1.setEnabled(isValidB());
 
    }

    private boolean isValidB(){

    if (numB()>1) return true;   
    
    return false;
    
    }
    
    private int numB(){
    
        int n=0;
        
    for (int i=0;i<pl.length;i++)
        if (pl[i]) n++;
    
    return n;
    }
    

    private void initComponents() {
        jPanel1 = new javax.swing.JPanel();
        jComboBox1 = new javax.swing.JComboBox();
        jPanel2 = new javax.swing.JPanel();
        jComboBox2 = new javax.swing.JComboBox();
        jPanel3 = new javax.swing.JPanel();
        jComboBox3 = new javax.swing.JComboBox();
        jPanel4 = new javax.swing.JPanel();
        jComboBox4 = new javax.swing.JComboBox();
        jButton1 = new javax.swing.JButton();

        getContentPane().setLayout(new javax.swing.BoxLayout(getContentPane(), javax.swing.BoxLayout.X_AXIS));

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
        jComboBox1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jComboBox1ActionPerformed(evt);
            }
        });

        jPanel1.add(jComboBox1);

        getContentPane().add(jPanel1);

        jComboBox2.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jComboBox2ActionPerformed(evt);
            }
        });

        jPanel2.add(jComboBox2);

        getContentPane().add(jPanel2);

        jComboBox3.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jComboBox3ActionPerformed(evt);
            }
        });

        jPanel3.add(jComboBox3);

        getContentPane().add(jPanel3);

        jComboBox4.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jComboBox4ActionPerformed(evt);
            }
        });

        jPanel4.add(jComboBox4);

        getContentPane().add(jPanel4);

        jButton1.setText("Start");
        jButton1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton1ActionPerformed(evt);
            }
        });

        getContentPane().add(jButton1);

        pack();
    }


    private void jButton1ActionPerformed(java.awt.event.ActionEvent evt) {
    
d.init(numB()+1,f,p); 

d.addG(new LocalPlayer("Player 1", d));


if (pl[0]) {    
if (((String)jComboBox1.getSelectedItem()).equals("CpuPlayer")) d.addG(new CpuPlayer("CPU1", d));
else d.addG(CaricaClasse.LoadGiocatore(((String)jComboBox1.getSelectedItem()),"CPU1", d));
}
if (pl[1]) {    
if (((String)jComboBox2.getSelectedItem()).equals("CpuPlayer")) d.addG(new CpuPlayer("CPU2", d));
else d.addG(CaricaClasse.LoadGiocatore(((String)jComboBox2.getSelectedItem()),"CPU2", d));
}
if (pl[2]) {    
if (((String)jComboBox3.getSelectedItem()).equals("CpuPlayer")) d.addG(new CpuPlayer("CPU3", d));
else d.addG(CaricaClasse.LoadGiocatore(((String)jComboBox3.getSelectedItem()),"CPU3", d));
}
if (pl[3]) {    
if (((String)jComboBox4.getSelectedItem()).equals("CpuPlayer")) d.addG(new CpuPlayer("CPU4", d));
else d.addG(CaricaClasse.LoadGiocatore(((String)jComboBox4.getSelectedItem()),"CPU4", d));
}

d.assegnaCarte();
p.repaint();
d.getGame().start();
        
    this.setVisible(false);    
    }

    private void jComboBox4ActionPerformed(java.awt.event.ActionEvent evt) {
    
    if (((String)jComboBox4.getSelectedItem()).matches("No Player \\p{Digit}")) pl[3]=false; 
    else pl[3]=true; 
    
    jButton1.setEnabled(isValidB());
    }

    private void jComboBox3ActionPerformed(java.awt.event.ActionEvent evt) {
    
    if (((String)jComboBox3.getSelectedItem()).matches("No Player \\p{Digit}")) pl[2]=false; 
    else pl[2]=true; 
    
    jButton1.setEnabled(isValidB());    
    }

    private void jComboBox2ActionPerformed(java.awt.event.ActionEvent evt) {
        
    if (((String)jComboBox2.getSelectedItem()).matches("No Player \\p{Digit}")) pl[1]=false; 
    else pl[1]=true;    

    jButton1.setEnabled(isValidB());
    }

    private void jComboBox1ActionPerformed(java.awt.event.ActionEvent evt) {
    
    if (((String)jComboBox1.getSelectedItem()).matches("No Player \\p{Digit}")) pl[0]=false; 
    else pl[0]=true;
    
    jButton1.setEnabled(isValidB());
    }

    private boolean[] pl;
    private Domino d;
    private JFrame f;
    private Graph p;

    private javax.swing.JButton jButton1;
    private javax.swing.JComboBox jComboBox1;
    private javax.swing.JComboBox jComboBox2;
    private javax.swing.JComboBox jComboBox3;
    private javax.swing.JComboBox jComboBox4;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JPanel jPanel2;
    private javax.swing.JPanel jPanel3;
    private javax.swing.JPanel jPanel4;

    
}
