/*
   Domino 1.0: Programma di Domino a 3,4,5 giocatori
   Copyright (C) 2005  Destroyer

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

package Domino;

public class Tavolo{

private Carta[][] tav;

public Tavolo(){

tav=new Carta[4][10];

}

protected Carta getCarta(int c){

int i=Carta.getSeme(c);
int j=Carta.getValore(c);

if (c>0 && c<41) return tav[i-1][j-1];

return null;

}

public boolean esisteC(int c){

if(null!=getCarta(c)) return true; 

return false;
}

public boolean esisteC(int s,int v){

if(s>0 && s<5 && v>0 && v<11 && null!=tav[s-1][v-1]) return true;

return false;
}

public boolean isValidAdd(int c){

int i=Carta.getSeme(c);
int j=Carta.getValore(c);

if (c>0 && c<41 && null==tav[i-1][j-1] && (j==5 || j>5 && null!=tav[i-1][j-2] || j<5 && null!=tav[i-1][j]))
return true;
              
return false;
}

protected void add(Carta c){

tav[c.seme-1][c.valore-1]=c;

}

protected void reset(){

for (int i=0;i<4;i++)
for (int j=0;j<10;j++)
tav[i][j]=null;

}


} 
