/*
   Domino 1.0: Programma di Domino a 3,4,5 giocatori
   Copyright (C) 2005  Destroyer

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

package Domino;

import java.io.*;
import java.util.*;

public class AboutDialog extends javax.swing.JDialog {
    

    public AboutDialog(java.awt.Frame parent) {
        super(parent);
        initComponents();
        
        jComboBox1.addItem("CpuPlayer");
        
        findAndAddP();
    }
 
        public void findAndAddP(){
    
    Vector<String> v=new Vector<String>(0,1);    
    
    File d = new File("./");
   
    File[] f=d.listFiles();
  
    for (int i=0;i<f.length;i++)
        if (f[i].getName().endsWith(".class") && CaricaClasse.isValidGiocatore(f[i].getName().substring(0, f[i].getName().length()-6)))
          v.add(f[i].getName());

    
    for (int i=0;i<v.size();i++){        
        String cl=v.elementAt(i).substring(0, v.elementAt(i).length()-6);
        if (!cl.equals("CpuPlayer") && !cl.equals("RandomPlayer") && !cl.equals("LocalPlayer") && !cl.equals("NetPlayer")){
        jComboBox1.addItem(cl);

    }}
        
        
    }
    

    private void initComponents() {
        jComboBox1 = new javax.swing.JComboBox();
        jTextArea1 = new javax.swing.JTextArea();
        jButton1 = new javax.swing.JButton();

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
        setTitle("Info Player");
        setModal(true);
        setResizable(false);
        jComboBox1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jComboBox1ActionPerformed(evt);
            }
        });

        getContentPane().add(jComboBox1, java.awt.BorderLayout.NORTH);

        jTextArea1.setEditable(false);
        getContentPane().add(jTextArea1, java.awt.BorderLayout.CENTER);

        jButton1.setText("Ok");
        jButton1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton1ActionPerformed(evt);
            }
        });

        getContentPane().add(jButton1, java.awt.BorderLayout.SOUTH);

        setSize(new java.awt.Dimension(300, 300));
    }


    private void jButton1ActionPerformed(java.awt.event.ActionEvent evt) {

        this.setVisible(false);
    }

    private void jComboBox1ActionPerformed(java.awt.event.ActionEvent evt) {

    if (((String)jComboBox1.getSelectedItem()).matches("CpuPlayer")) jTextArea1.setText(CpuPlayer.about()); 
    else jTextArea1.setText(CaricaClasse.leggiAbout((String)jComboBox1.getSelectedItem()));    
        
        
    }
      
    

    private javax.swing.JButton jButton1;
    private javax.swing.JComboBox jComboBox1;
    private javax.swing.JTextArea jTextArea1;

    
}
