/*
   Domino 1.0: Programma di Domino a 3,4,5 giocatori
   Copyright (C) 2005  Destroyer

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

package Domino;

public class Carta {

public static final int C=1;
public static final int Q=2;
public static final int F=3;
public static final int P=4;
public static final int Q5=getCarta(Q,5);

public final int carta;
public final int valore;
public final int seme;


public boolean valid;
public int pr;


public Carta(int carta){

this.carta=carta;
valore=getValore(carta);
seme=getSeme(carta);

}

public Carta(int seme,int valore){

this.seme=seme;
this.valore=valore;
carta=getCarta(seme, valore);

}

public static int getSeme(int c){
int r=-1;
if (c>0 && c<41) 
r=(int)((c-1+10)/10);
return r;
}

public static int getValore(int c){
int r=-1;
if (c>0 && c<41) 
r=(c-(getSeme(c)-1)*10);
return r;
}

public static int getCarta(int s,int v){
int r=-1;

if (s>0 && s<5 && v>0 && v<11) r=(s-1)*10+v;

return r;
}

} 
