/*
   Domino 1.0: Programma di Domino a 3,4,5 giocatori
   Copyright (C) 2005  Destroyer

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

package Domino;

public class CpuPlayer extends Giocatore {
    

    public static String about(){

    return "CpuPlayer versione 1.0\n" +
            "www.xDestroyer.altervista.org\n" +
            "Destroyer@email.it";
    }
    
    public CpuPlayer(String nome,Domino d) {

    super(nome,d);
       
    }
    
    public Carta getCarta(){
    
    int num=this.sizeMano();
    int r=0;
    
    id=-1;
    
    if (this.nValid()==0) return null;
    
    for (int i=0;i<num;i++){
        this.readC(i).valid=isValidAdd(this.readC(i).carta);
        this.readC(i).pr=0;
    }
    
    for (int i=0;i<num;i++)
        if (this.readC(i).valid) 
            for (int j=0;j<num;j++)
            if(this.readC(i).seme==this.readC(j).seme){ 
            int dist=0;
            
                    if (this.readC(i).valore==5 || 
                        this.readC(i).valore>5 && this.readC(j).valore>5 ||
                        this.readC(i).valore<5 && this.readC(j).valore<5) dist=Math.abs(this.readC(i).valore-this.readC(j).valore); 
                
            if(this.readC(i).pr<dist) this.readC(i).pr=dist;
            
                   }
            
        for (int i=0;i<num;i++)
               if (this.readC(i).valid)
                   if(this.readC(i).pr>=this.readC(r).pr) r=i;
                   
    id=r;
    return this.remC(r);
    }
    

}
