/*
   Domino 1.0: Programma di Domino a 3,4,5 giocatori
   Copyright (C) 2005  Destroyer

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

package Domino;

import javax.swing.JFrame;

public class Game extends Thread{

    private JFrame f;
    private Graph p;
    private Domino d;
    private boolean pausa, attivo;
    private boolean ready;
    private int pos;
    
    public Game(JFrame f,Graph p,Domino d) {
    this.f=f;
    this.p=p;
    this.d=d;    
    attivo=pausa=true;
    pos=0;
    }
 
    
    public void run(){
    
    ready=false;
    
    d.gioca();    
        
    while (attivo){
    
    ready=false;
    
    if ((d.getG(0).nValid()!=0 || !p.getAutoPassState()) && !d.getG(0).isEnd())  pausa=true; 
    else ((LocalPlayer) d.getG(0)).selectC(-1);
   
    if (pausa) ready=true;

 if (ready && !p.getAutoPassState() && !d.getG(0).isEnd() && d.getG(0).nValid()==0)
                 p.jButton.setVisible(true);
 
    
   try{
   synchronized(this) {
      
   while (pausa) 
       wait();
   }
   }catch(Exception e){}
    

    ready=false;
    
    d.gioca(d.getG(0).getCarta());
    
    if (isEnd()){
        termina();
        (new EndDialog(f,true,p,d)).setVisible(true);
    }
    
    }
        
    }
    
    protected void termina(){
    attivo=false;
    }
    
    public boolean isActive(){
    return attivo;   
    }
    
    public int getPos(){
         return ++pos;
    }
    
    public void sveglia(){
    pausa=false;
    }

    public boolean isReady(){
    return ready;
    }
    
    public boolean isEnd(){
    
    for(int i=0;i<d.numeroG();i++)
       if (!d.getG(i).isEnd()) return false;
        
    return true;    
    }
    
}
